import{Type as t}from"@freik/core-utils"
import r from"minimist"
import e from"path"
import{EnumerateBoards as o}from"./board.js"
import{IsConfigPresent as a,ReadConfig as i}from"./config.js"
import{Dump as n,FlushOutput as s,SetOutputFile as m}from"./dump.js"
import{GetLibraries as f}from"./libraries.js"
import{ParseFile as l}from"./parser.js"
import{MakePlatform as g}from"./platform.js"
import{GetGnuMakeTarget as p}from"./targets/gnumake.js"
export function ShowHelp(r){t.isUndefined(r)||((t.isString(r)?[r]:r).forEach(n("err")),n("err")("")),n("err")("\nUsage: {flags} rootDir {lib1Dir lib2Dir lib3Dir}\n  rootDir is where you can find 'boards.txt' and 'platform.txt'\n  flags:\n    --config|-c <file.json> Read the config from the json file\n    --out|-o <filename> Spit the output into filename\n    --target|-t <gnumake> Generate a project for the given target (only GNUMake currently...)\n"),process.exit(0)}const c=p()
export function GetTarget(){return c}export default async function u(...n){try{const p=await async function(e){const o=r(e,{string:["config","target","out","help"],alias:{c:"config",t:"target",o:"out",h:"help","?":"help"},default:{target:"gnumake"}})
if(t.hasStr(o,"help")&&ShowHelp(),t.hasStr(o,"config")&&await i(o.config),m(o?.out),t.hasStr(o,"target")&&"gnumake"!==o.target.toLocaleLowerCase())throw Error(`Command line error: Unsupported target ${o.target}`)
return o._}(n)
0!==p.length||a()||ShowHelp("Missing command line or configuration")
const u=p[0],h=p.slice(1),w=e.join(u,"boards.txt"),d=o(await l(w)),j=e.join(u,"platform.txt"),S=g(await l(j)),b=await f(u,h)
await c.emit(j,S,d,b),await s()}catch(r){const e=t.hasStr(r,"name")?r.name:"<unknown>",o=t.hasStr(r,"message")?r.message:"<no message>"
ShowHelp(`Error: ${e} @ ${t.hasStr(r,"fileName")?r.fileName:"<no filename>"}#${t.has(r,"lineNumber")&&t.isNumber(r.lineNumber)?r.lineNumber:-1}:\n${o}`)}}