import{Type as e}from"@freik/core-utils"
import*as n from"path"
import{GetFileList as s}from"../files.js"
import{GetNestedChild as t}from"../symbols.js"
import{GetPlainValue as o,MakeDependentValue as _,MakeResolve as S,QuoteIfNeeded as p,ResolveString as r,Unquote as a}from"../utils.js"
import{GetLibDefs as u}from"./gmLibs.js"
import{MakePrefixer as c}from"./gmPrefixer.js"
import{MakeAppend as i,MakeDeclDef as l,MakeDefinitions as R,MakeIfeq as d,MakeSeqDef as $,MakeSrcList as O,MakeUnDecl as A}from"./gmUtils.js"
export async function BuildPlatform(f,h,E,U,C){const m=[l("BUILD_CORE_PATH","${RUNTIME_PLATFORM_PATH}/cores/${BUILD_CORE}",["RUNTIME_PLATFORM_PATH","BUILD_CORE"])],I=R({name:"fake",children:E.misc},o,null),L=function(e){const n=e.tools?R({name:"fake2",children:new Map([["fake2",e.tools]])},o,null,(function(e){for(;e.parent;e=e.parent)if("tools"===e.name)return!0
return"tools"===e.name})):[],s=n.filter((e=>e.name.endsWith("_CMD"))),_=n.filter((e=>e.name.endsWith("_MACOSX"))),S=n.filter((e=>e.name.endsWith("_WINDOWS"))),p=d("${RUNTIME_OS}","macosx"),r=[]
for(const e of _){const n=e.name.substring(0,e.name.lastIndexOf("_MACOSX"))
r.push(l(n,e.value,e.dependsOn,[p]))}const a=d("${RUNTIME_OS}","windows")
for(const e of S){const n=e.name.substring(0,e.name.lastIndexOf("_WINDOWS"))
r.push(l(n,e.value,e.dependsOn,[a]))}if(r.push(...s.map((e=>A(e.name,e.value,e.dependsOn)))),e.tools)for(const[n,s]of e.tools.children){const e=t(s,"upload","pattern")
if(!e)continue
const _=d("${UPLOAD_USE_1200BPS_TOUCH}","true"),S=l("UPLOAD_EXTRA_FLAGS","--touch 1200",[],[_])
r.push(S)
const p=d("${UPLOAD_TOOL}",n),a=o(e),u=a.value.replace("${CMD}","${TOOLS_"+n.toUpperCase()+"_CMD}")
a.unresolved.delete("CMD")
const c=l("UPLOAD_PATTERN",u.replace("${BUILD_PATH}","$(abspath ${BUILD_PATH})"),[...a.unresolved,S.name],[p])
r.push(c)}return r}(E),T=function(n){function s(e,n,s,t){const o=_(e)
if(!o||!o.unresolved.has(s)||!o.unresolved.has(n))throw new Error("Missing required recipe pattern")
return S(S(o,s,t),n,"$@")}function t(e,n){const t=s(e,"OBJECT_FILE","SOURCE_FILE","$<")
return{src:n,dst:"o",command:(o=t.value,o.split(" ").map((e=>{if("${INCLUDES}"===e)return"${SYS_INCLUDES} ${USER_INCLUDES}"
const n=e.indexOf('"'),s=e.lastIndexOf('"')
if(n<0&&s<0)return e
if(0===n&&s===e.length-1&&e.indexOf('"',1)===s)return e
const t=e.indexOf("'"),o=e.lastIndexOf("'")
return 0===t&&o===e.length-1&&e.indexOf("'",1)===o?e:`'${e}'`})).join(" ")),dependsOn:[...t.unresolved]}
var o}const o=[]
o.push(t(n.s.pattern,"S")),o.push(t(n.c.pattern,"c")),o.push(t(n.cpp.pattern.replace(' "{source_file}" -o ',' -x c++ "{source_file}" -o '),"ino")),o.push(t(n.cpp.pattern,"cpp"))
const p=s(n.ar.pattern,"ARCHIVE_FILE_PATH","OBJECT_FILE","$#@!")
o.push({src:"o",dst:"a",command:p.value.replace('"$#@!"',"$^"),dependsOn:[...p.unresolved]})
const a=r(S(S(_(n.link.pattern),"OBJECT_FILES","${USER_OBJS}"),"ARCHIVE_FILE","system.a"),"${BUILD_PATH}/${BUILD_PROJECT_NAME}.elf","$@")
o.push({src:"o-a",dst:"elf",command:a.value,dependsOn:[...a.unresolved]})
const u=n.objcopy.find((e=>"hex"===e.name))
let c
e.isUndefined(u)||(c=r(r(_(u.pattern.pattern),"${BUILD_PATH}/${BUILD_PROJECT_NAME}.elf","$<"),"${BUILD_PATH}/${BUILD_PROJECT_NAME}.hex","$@"),o.push({src:"elf",dst:"hex",command:c.value,dependsOn:[...c.unresolved]}))
const i=n.objcopy.find((e=>"zip"===e.name))
let l
return e.isUndefined(i)||(l=r(r(_(i.pattern.pattern),"${BUILD_PATH}/${BUILD_PROJECT_NAME}.hex","$<"),"${BUILD_PATH}/${BUILD_PROJECT_NAME}.zip","$@"),o.push({src:"hex",dst:"zip",command:l.value,dependsOn:[...l.unresolved]}),o.push({src:"zip",dst:"flash",command:"${UPLOAD_PATTERN} ${UPLOAD_EXTRA_FLAGS}",dependsOn:[]})),c&&!l&&o.push({src:"hex",dst:"flash",command:"${UPLOAD_PATTERN} ${UPLOAD_EXTRA_FLAGS}",dependsOn:[]}),o}(E.recipes),P=new Set(h.filter((e=>"BUILD_CORE"===e.name)).map((e=>e.value))),D=new Set(h.filter((e=>"BUILD_VARIANT"===e.name)).map((e=>e.value))),B=[],N=c([[f.find((e=>"RUNTIME_PLATFORM_PATH"===e.name))?.value||"!@#$","${RUNTIME_PLATFORM_PATH}"]])
for(const e of P){const{c:t,cpp:o,s:_,paths:S}=await s(n.join(a(U),"cores",e)),r=[d("${BUILD_CORE}",e)]
t.length&&B.push(O("C_SYS_SRCS",t,"BUILD_CORE",r,N)),o.length&&B.push(O("CPP_SYS_SRCS",o,"BUILD_CORE",r,N)),_.length&&B.push(O("S_SYS_SRCS",_,"BUILD_CORE",r,N)),B.push(i("SYS_INCLUDES"," "+p(`-I${N(n.join(a(U),"cores",e).replaceAll("\\","/"))}`),["BUILD_CORE"],r))
const u=S.map(p).map(N).join(" ")
u.length>0&&B.push(i("VPATH_CORE",u,["BUILD_CORE"],r))}for(const e of D){const{c:t,cpp:o,s:_,paths:S,inc:r}=await s(n.join(a(U),"variants",e)),u=[d("${BUILD_VARIANT}",e)]
t.length&&B.push(O("C_SYS_SRCS",t,"BUILD_VARIANT",u,N)),o.length&&B.push(O("CPP_SYS_SRCS",o,"BUILD_VARIANT",u,N)),_.length&&B.push(O("S_SYS_SRCS",_,"BUILD_VARIANT",u,N)),B.push(O("SYS_INCLUDES",r,"BUILD_VARIANT",u,N,"-I"))
const c=S.map(p).map(N).join(" ")
c.length>0&&B.push(i("VPATH_CORE",c,["BUILD_VARIANT"],u))}C.forEach((e=>{B.push(...u(e,N))})),B.push(l("SYS_SRC","${C_SYS_SRCS} ${CPP_SYS_SRCS} ${S_SYS_SRCS}")),B.push(l("USER_SRC","${USER_C_SRCS} ${USER_CPP_SRCS} ${USER_S_SRCS}")),B.push(l("ALL_SRC","${SYS_SRC} ${USER_SRC}")),B.push($("VPATH","${VPATH}:${VPATH_MORE}:${VPATH_CORE}:${VPATH_VAR}"))
const H=(e,n,s)=>l(e,`\\\n  $(addprefix \${BUILD_PATH}/, \\\n    $(patsubst %.c, %.c.${s}, \\\n      $(patsubst %.cpp, %.cpp.${s}, \\\n        $(patsubst %.ino, %.ino.${s}, \\\n          $(patsubst %.S, %.S.${s}, $(notdir \${${n}}))))))`,[],[])
return B.push(H("SYS_OBJS","SYS_SRC","o")),B.push(H("USER_OBJS","USER_SRC","o")),B.push(l("ALL_OBJS","${USER_OBJS} ${SYS_OBJS}")),B.push(H("SYS_JSN","SYS_SRC","jsn")),B.push(H("USER_JSN","USER_SRC","jsn")),{defs:[...m,...I,...L,...B],rules:T}}